/*******************************************************************************
 * FoxCombatMessage generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxCombatMessage extends Object;

var const localized array<localized string> DoubleKillMessages;
var const localized array<localized string> TripleKillMessages;
var const localized array<localized string> OverKillMessages;
var const localized array<localized string> MonsterKillMessages;
var const localized string LocStringHeadshot;
var const localized string LocStringKillingSpree;
var const localized string LocStringDominating;
var const localized string LocStringUnstoppable;
var const localized string LocStringGodlike;
var const localized string LocStringBeastMode;
var const localized string LocStringCapturedPoint;
var const localized string LocStringHackedPoint;
var const localized string LocStringCapturedFlag;
var const localized string LocStringBecameHighThreat;
var const localized string LocStringBecameWarlord;
var const localized string LocStringYou;
var const localized string LocStringYourself;
var const localized string LocStringHit;
var const localized string LocStringRepaired;
var const localized string LocStringHealed;
var transient array<MultiKill> CachedMultiKillInfo;

function KillMessage(FoxPC ForPC, FoxPRI KillerPRI, FoxPRI KilledPRI, class<DamageType> DamageType, class<FoxWeapon> WeaponClass, bool bHeadShot, bool bMultikillEnd)
{
    local int I;

    // End:0x37
    if(KillerPRI == none)
    {
        PumpSuicide(ForPC, KilledPRI, DamageType);
    }
    // End:0x144
    else
    {
        AddPlayerToMultiKillInfo(KillerPRI, KilledPRI, DamageType, WeaponClass, bHeadShot, CachedMultiKillInfo);
        // End:0x144
        if(bMultikillEnd)
        {
            I = 0;
            J0x90:
            // End:0x144 [Loop If]
            if(I < CachedMultiKillInfo.Length)
            {
                // End:0x136
                if(CachedMultiKillInfo[I].KillerPRI == KillerPRI)
                {
                    PumpKillMessages(ForPC, KillerPRI, CachedMultiKillInfo[I].KilledInfo);
                    CachedMultiKillInfo.Remove(I, 1);
                    // [Explicit Break]
                    goto J0x144;
                }
                ++ I;
                // [Loop Continue]
                goto J0x90;
            }
        }
    }
    //return;    
}

function DamageMessage(FoxPRI Other, FoxTypes.EDamageType TypeOfDamage, class<DamageType> DamageTypeClass, int TotalDamage, bool bWeInstigated, bool bHeadShot)
{
    // End:0x11
    if(Other == none)
    {
        return;
    }
    //return;    
}

static function AddPlayerToMultiKillInfo(FoxPRI KillerPRI, FoxPRI KilledPRI, class<DamageType> DamageType, class<FoxWeapon> WeaponClass, bool bHeadShot, out array<MultiKill> OutMultiKillInfo)
{
    local int I, J;
    local KilledPlayer NewKilledPlayer;
    local KillInfo NewKilledInfo;
    local MultiKill NewMultiKill;

    NewKilledPlayer.KilledPlayer = KilledPRI;
    NewKilledPlayer.bHeadShot = bHeadShot;
    NewKilledInfo.KilledPlayers.AddItem(NewKilledPlayer);
    NewKilledInfo.DamageTypeClass = DamageType;
    NewKilledInfo.WeaponClass = WeaponClass;
    NewMultiKill.KilledInfo.AddItem(NewKilledInfo);
    NewMultiKill.KillerPRI = KillerPRI;
    I = 0;
    J0x11D:
    // End:0x2F0 [Loop If]
    if(I < OutMultiKillInfo.Length)
    {
        // End:0x2E2
        if(OutMultiKillInfo[I].KillerPRI == KillerPRI)
        {
            J = 0;
            J0x174:
            // End:0x2AD [Loop If]
            if(J < OutMultiKillInfo[I].KilledInfo.Length)
            {
                // End:0x29F
                if((OutMultiKillInfo[I].KilledInfo[J].DamageTypeClass == DamageType) && OutMultiKillInfo[I].KilledInfo[J].WeaponClass == WeaponClass)
                {
                    OutMultiKillInfo[I].KilledInfo[J].KilledPlayers.AddItem(NewKilledPlayer);
                    return;
                }
                ++ J;
                // [Loop Continue]
                goto J0x174;
            }
            OutMultiKillInfo[I].KilledInfo.AddItem(NewKilledInfo);
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x11D;
    }
    OutMultiKillInfo.AddItem(NewMultiKill);
    //return;    
}

function PumpSuicide(FoxPC ForPC, FoxPRI KilledPRI, class<DamageType> TheDamageType)
{
    local string DetailText;

    // End:0xA1
    if((TheDamageType != none) && class<FoxDamageType>(TheDamageType) != none)
    {
        DetailText = class<FoxDamageType>(TheDamageType).static.GetSuicideString();
        ForPC.MyFoxHud.AddCombatLog(KilledPRI, DetailText);
    }
    //return;    
}

function PumpKillMessages(FoxPC ForPC, FoxPRI KillerPRI, array<KillInfo> TheKilledInfo)
{
    // End:0xF9
    if((TheKilledInfo.Length == 1) && TheKilledInfo[0].KilledPlayers.Length == 1)
    {
        PumpSingleKill(ForPC, KillerPRI, TheKilledInfo[0].KilledPlayers[0].KilledPlayer, TheKilledInfo[0].DamageTypeClass, TheKilledInfo[0].WeaponClass, TheKilledInfo[0].KilledPlayers[0].bHeadShot);
    }
    // End:0x11E
    else
    {
        PumpMultiKill(ForPC, KillerPRI, TheKilledInfo);
    }
    //return;    
}

function PumpSingleKill(FoxPC ForPC, FoxPRI KillerPRI, FoxPRI KilledPRI, class<DamageType> DamageType, class<FoxWeapon> WeaponClass, bool bHeadShot)
{
    local string DetailText, WeaponName;

    // End:0x286
    if((DamageType != none) && class<FoxDamageType>(DamageType) != none)
    {
        DetailText = class<FoxDamageType>(DamageType).static.GetKillString(KilledPRI, ForPC);
        // End:0x9E
        if(bHeadShot)
        {
            DetailText @= ("+" $ LocStringHeadshot);
        }
        // End:0x10F
        if(class<FoxDamageType>(DamageType) != none)
        {
            WeaponName = GetDamageTypeName(class<FoxDamageType>(DamageType));
            // End:0x10F
            if(WeaponName != "")
            {
                DetailText @= ("+" $ WeaponName);
            }
        }
        // End:0x240
        if((WeaponName == "") && WeaponClass != none)
        {
            // End:0x1E5
            if(((WeaponClass.default.WeaponType == 5) || WeaponClass.default.WeaponType == 4) || WeaponClass.default.WeaponType == 2)
            {
                WeaponName = class'FoxLoadoutInfo'.static.GetGearWeaponName(WeaponClass);
            }
            // End:0x20D
            else
            {
                WeaponName = WeaponClass.default.FriendlyName;
            }
            // End:0x240
            if(WeaponName != "")
            {
                DetailText @= ("+" $ WeaponName);
            }
        }
        ForPC.MyFoxHud.AddCombatLog(KillerPRI, DetailText);
    }
    //return;    
}

function PumpMultiKill(FoxPC ForPC, FoxPRI KillerPRI, array<KillInfo> TheKilledInfo)
{
    local int I, J;
    local string DetailText, KilledPlayerName;
    local int NumKills, MultiKillType;
    local string FlavorText, WeaponName;

    I = 0;
    J0x0B:
    // End:0x4AA [Loop If]
    if(I < TheKilledInfo.Length)
    {
        // End:0x49
        if(I > 0)
        {
            DetailText @= "";
        }
        J = 0;
        J0x54:
        // End:0x33B [Loop If]
        if(J < TheKilledInfo[I].KilledPlayers.Length)
        {
            // End:0xD5
            if(TheKilledInfo[I].KilledPlayers[J].KilledPlayer == none)
            {
            }
            // End:0x32D
            else
            {
                // End:0xFD
                if(J > 0)
                {
                    DetailText $= ", ";
                }
                KilledPlayerName = TheKilledInfo[I].KilledPlayers[J].KilledPlayer.PlayerName;
                // End:0x2B3
                if(ForPC.WorldInfo.GRI.OnSameTeam(TheKilledInfo[I].KilledPlayers[J].KilledPlayer, ForPC) || TheKilledInfo[I].KilledPlayers[J].KilledPlayer == ForPC.PlayerReplicationInfo)
                {
                    KilledPlayerName = class'FoxUI'.static.WrapStringInColor(KilledPlayerName, class'FoxUI'.default.BlueTeamColor);
                }
                // End:0x304
                else
                {
                    KilledPlayerName = class'FoxUI'.static.WrapStringInColor(KilledPlayerName, class'FoxUI'.default.RedTeamColor);
                }
                DetailText $= KilledPlayerName;
                ++ NumKills;
            }
            ++ J;
            // [Loop Continue]
            goto J0x54;
        }
        // End:0x3E6
        if(class<FoxDamageType>(TheKilledInfo[I].DamageTypeClass) != none)
        {
            WeaponName = GetDamageTypeName(class<FoxDamageType>(TheKilledInfo[I].DamageTypeClass));
            // End:0x3E6
            if(WeaponName != "")
            {
                DetailText @= ("+" $ WeaponName);
            }
        }
        // End:0x49C
        if((WeaponName == "") && TheKilledInfo[I].WeaponClass != none)
        {
            WeaponName = TheKilledInfo[I].WeaponClass.default.FriendlyName;
            // End:0x49C
            if(WeaponName != "")
            {
                DetailText @= ("+" $ WeaponName);
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    MultiKillType = class'FoxKillingSpreeMessage'.static.GetMultiKillType(NumKills);
    switch(MultiKillType)
    {
        // End:0x517
        case 5:
            FlavorText = DoubleKillMessages[Rand(DoubleKillMessages.Length)];
            // End:0x592
            break;
        // End:0x53F
        case 6:
            FlavorText = TripleKillMessages[Rand(TripleKillMessages.Length)];
            // End:0x592
            break;
        // End:0x567
        case 7:
            FlavorText = OverKillMessages[Rand(OverKillMessages.Length)];
            // End:0x592
            break;
        // End:0x58F
        case 8:
            FlavorText = MonsterKillMessages[Rand(MonsterKillMessages.Length)];
            // End:0x592
            break;
        // End:0xFFFF
        default:
            ForPC.MyFoxHud.AddCombatLog(KillerPRI, FlavorText @ DetailText);
            //return;
    }    
}

static function string GetDamageTypeName(class<FoxDamageType> DamageType)
{
    // End:0xD6
    if(DamageType != none)
    {
        // End:0x8B
        if((DamageType.Name == 'FoxDamageType_Crushed') || DamageType.Name == 'FoxDamageType_RanOver')
        {
            return class'FoxHudUI'.default.LocStringHardSuit;
        }
        // End:0xD6
        else
        {
            // End:0xD6
            if(DamageType.Name == 'FoxDamageType_Turret')
            {
                return class'FoxGame_AITurretPawn'.default.LocStringTurretName;
            }
        }
    }
    return "";
    //return ReturnValue;    
}

function KillSpreeMessage(FoxPC ForPC, FoxPRI KillSpreePRI, byte KillSpreeType)
{
    local string KillSpreeString;

    switch(KillSpreeType)
    {
        // End:0x2E
        case 0:
            KillSpreeString = LocStringKillingSpree;
            // End:0x9D
            break;
        // End:0x49
        case 1:
            KillSpreeString = LocStringDominating;
            // End:0x9D
            break;
        // End:0x64
        case 2:
            KillSpreeString = LocStringUnstoppable;
            // End:0x9D
            break;
        // End:0x7F
        case 3:
            KillSpreeString = LocStringGodlike;
            // End:0x9D
            break;
        // End:0x9A
        case 4:
            KillSpreeString = LocStringBeastMode;
            // End:0x9D
            break;
        // End:0xFFFF
        default:
            ForPC.MyFoxHud.AddCombatLog(KillSpreePRI, KillSpreeString);
            //return;
    }    
}

function GameplayMessage(FoxPC ForPC, FoxPRI PRI, FoxTypes.EScoreEvents EventType)
{
    local string GameplayMessageString;

    switch(EventType)
    {
        // End:0x2E
        case 2:
            GameplayMessageString = LocStringCapturedFlag;
            // End:0x9D
            break;
        // End:0x49
        case 8:
            GameplayMessageString = LocStringCapturedPoint;
            // End:0x9D
            break;
        // End:0x64
        case 10:
            GameplayMessageString = LocStringHackedPoint;
            // End:0x9D
            break;
        // End:0x7F
        case 13:
            GameplayMessageString = LocStringBecameHighThreat;
            // End:0x9D
            break;
        // End:0x9A
        case 14:
            GameplayMessageString = LocStringBecameWarlord;
            // End:0x9D
            break;
        // End:0xFFFF
        default:
            ForPC.MyFoxHud.AddCombatLog(PRI, GameplayMessageString);
            //return;
    }    
}

defaultproperties
{
    DoubleKillMessages(0)="double kill"
    DoubleKillMessages(1)="double down"
    TripleKillMessages(0)="triple kill"
    TripleKillMessages(1)="tripled up"
    OverKillMessages(0)="overkill"
    OverKillMessages(1)="cleared out"
    MonsterKillMessages(0)="monster kill"
    MonsterKillMessages(1)="clean swept"
    MonsterKillMessages(2)="eradicated"
    LocStringHeadshot="Headshot"
    LocStringKillingSpree="killing spree"
    LocStringDominating="dominating"
    LocStringUnstoppable="unstoppable"
    LocStringGodlike="professional killer"
    LocStringCapturedPoint="captured node"
    LocStringHackedPoint="hacked node"
    LocStringCapturedFlag="captured flag"
    LocStringBecameHighThreat="is now High Threat"
    LocStringBecameWarlord="is now Warlord"
    LocStringYou="You"
    LocStringYourself="Yourself"
    LocStringHit="Hit"
    LocStringRepaired="Repaired"
    LocStringHealed="Healed"
}